"use strict";
Object.defineProperty(exports, "__esModule", {
  value: true
});
function _export(target, all) {
  for (var name in all)
    Object.defineProperty(target, name, {
      enumerable: true,
      get: all[name]
    });
}
_export(exports, {
  resolvePath: function() {
    return _resolvePath.default;
  },
  default: function() {
    return _default;
  }
});
const _interop_require_default = require("@swc/helpers/_/_interop_require_default");
const _normalizeOptions = /* @__PURE__ */ _interop_require_default._(require("./normalizeOptions"));
const _resolvePath = /* @__PURE__ */ _interop_require_default._(require("./resolvePath"));
const _call = /* @__PURE__ */ _interop_require_default._(require("./transformers/call"));
const _import = /* @__PURE__ */ _interop_require_default._(require("./transformers/import"));
const importVisitors = {
  CallExpression: _call.default,
  "ImportDeclaration|ExportDeclaration": _import.default
};
const visitor = {
  Program: {
    enter(programPath, state) {
      programPath.traverse(importVisitors, state);
    },
    exit(programPath, state) {
      programPath.traverse(importVisitors, state);
    }
  }
};
const _default = ({ types }) => ({
  name: "module-resolver",
  manipulateOptions(opts) {
    if (opts.filename === void 0) {
      opts.filename = "unknown";
    }
  },
  pre(file) {
    this.types = types;
    const currentFile = file.opts.filename;
    this.normalizedOpts = (0, _normalizeOptions.default)(currentFile, this.opts);
    this.moduleResolverVisited = /* @__PURE__ */ new Set();
  },
  visitor,
  post() {
    this.moduleResolverVisited.clear();
  }
});
